<script lang="ts" setup>

import { ref, reactive } from 'vue';
import { IRegister,IregisterErrors } from '../../types/types';
import { registerValidation } from "../../validations/registerRules";

const formData = reactive<IRegister>({ username: undefined, email: undefined, password: undefined });
const formError = reactive<IregisterErrors>({ username: undefined, email: undefined, password: undefined });

const registerEvent = () => {
    const result = registerValidation(formData, formError);
    if (result.passed) {
        console.log(result);
    }
}

</script>

<template>
    <div class="login-body">
        <div class="login-box">
            <h2>REGISTER</h2>
            <form>
                <div class="user-box">
                    <input v-model="formData.username" type="text">
                    <label :class="[formError.username ? 'label_err' : null]">{{ formError.username ? formError.username
                            : 'Username'
                    }}</label>
                </div>
                <div class="user-box">
                    <input v-model="formData.email" type="text">
                    <label :class="[formError.email ? 'label_err' : null]">{{ formError.email ? formError.email
                            : 'E-mail'
                    }}</label>
                </div>
                <div class="user-box">
                    <input v-model="formData.password" type="password">
                    <label :class="[formError.password ? 'label_err' : null]">{{ formError.password ? formError.password
                            : 'Password'
                    }}</label>
                </div>
                <a href="#" :class="[(formError.username || formError.password) ? 'btn-login-warn' : 'btn-login loader']"
                    @click="registerEvent">
                    <span :class="[(formError.username || formError.password) ? 'warn' : 'prog']"></span>
                    <span :class="[(formError.username || formError.password) ? 'warn' : 'prog']"></span>
                    <span :class="[(formError.username || formError.password) ? 'warn' : 'prog']"></span>
                    <span :class="[(formError.username || formError.password) ? 'warn' : 'prog']"></span>
                    Sign Up
                </a>
                <p class="text-center mb-0 mt-3 txtblu">Already have an Account? <RouterLink to="/login" class="txtblu"> Sign In</RouterLink></p>
            </form>
        </div>
    </div>
</template>

<style scoped>
.login-body {
    height: 948px;
    margin: 0;
    padding: 0;
    font-family: sans-serif;
    background: #000;
    /* background: linear-gradient(#141e30, #243b55) !important; */
}

.login-box {
    position: absolute;
    top: 50%;
    left: 50%;
    width: 400px;
    padding: 40px;
    transform: translate(-50%, -50%);
    background: #191C24;
    box-sizing: border-box;
    box-shadow: 0 15px 25px rgba(0, 0, 0, .6);
    border-radius: 10px;
}

.login-box h2 {
    margin: 0 0 30px;
    padding: 0;
    color: #fff;
    text-align: center;
}

.login-box .user-box {
    position: relative;
}

.login-box .user-box input {
    width: 100%;
    padding: 10px 0;
    font-size: 16px;
    color: #fff;
    margin-bottom: 30px;
    border: none;
    border-bottom: 1px solid #fff;
    outline: none;
    background: transparent;
}

.login-box .user-box label {
    position: absolute;
    top: 0;
    left: 0;
    padding: 10px 0;
    font-size: 16px;
    color: #fff;
    pointer-events: none;
    transition: .5s;
}

.login-box .user-box input:focus~label,
.login-box .user-box input:valid~label {
    top: -20px;
    left: 0;
    color: #03e9f4;
    font-size: 12px;
}

.login-box form .btn-login {
    position: relative;
    display: inline-block;
    padding: 10px 20px;
    color: #03e9f4;
    font-size: 16px;
    text-decoration: none;
    text-transform: uppercase;
    overflow: hidden;
    transition: .5s;
    margin-top: 10px;
    letter-spacing: 4px
}

.login-box .loader:hover {
    /* background: #03e9f4; */
    color: #03e9f4;
    border-radius: 5px;
    box-shadow: 0 0 5px #03e9f4,
        0 0 25px #03e9f4,
        0 0 50px #03e9f4,
        0 0 100px #03e9f4
}

/* warn */
.login-box form .btn-login-warn {
    position: relative;
    display: inline-block;
    padding: 10px 20px;
    color: red;
    font-size: 16px;
    text-decoration: none;
    text-transform: uppercase;
    overflow: hidden;
    transition: .5s;
    margin-top: 10px;
    letter-spacing: 4px
}

.login-box .loader-warn:hover {
    background: red;
    color: #fff;
    border-radius: 5px;
    box-shadow: 0 0 5px red,
        0 0 25px red,
        0 0 50px red,
        0 0 100px red;
}

.login-box a .warn {
    position: absolute;
    display: block;
}

.login-box a .warn:nth-child(1) {
    top: 0;
    left: -100%;
    width: 100%;
    height: 2px;
    background: linear-gradient(90deg, transparent, red);
    animation: btn-anim1 1s linear infinite;
}

.login-box a .warn:nth-child(2) {
    top: -100%;
    right: 0;
    width: 2px;
    height: 100%;
    background: linear-gradient(180deg, transparent, red);
    animation: btn-anim2 1s linear infinite;
    animation-delay: .25s
}

.login-box a .warn:nth-child(3) {
    bottom: 0;
    right: -100%;
    width: 100%;
    height: 2px;
    background: linear-gradient(270deg, transparent, red);
    animation: btn-anim3 1s linear infinite;
    animation-delay: .5s
}

.login-box a .warn:nth-child(4) {
    bottom: -100%;
    left: 0;
    width: 2px;
    height: 100%;
    background: linear-gradient(360deg, transparent, red);
    animation: btn-anim4 1s linear infinite;
    animation-delay: .75s
}

/* warn */


.login-box a .prog {
    position: absolute;
    display: block;
}

.login-box a .prog:nth-child(1) {
    top: 0;
    left: -100%;
    width: 100%;
    height: 2px;
    background: linear-gradient(90deg, transparent, #03e9f4);
    animation: btn-anim1 1s linear infinite;
}


@keyframes btn-anim1 {
    0% {
        left: -100%;
    }

    50%,
    100% {
        left: 100%;
    }
}

.login-box a .prog:nth-child(2) {
    top: -100%;
    right: 0;
    width: 2px;
    height: 100%;
    background: linear-gradient(180deg, transparent, #03e9f4);
    animation: btn-anim2 1s linear infinite;
    animation-delay: .25s
}

@keyframes btn-anim2 {
    0% {
        top: -100%;
    }

    50%,
    100% {
        top: 100%;
    }
}

.login-box a .prog:nth-child(3) {
    bottom: 0;
    right: -100%;
    width: 100%;
    height: 2px;
    background: linear-gradient(270deg, transparent, #03e9f4);
    animation: btn-anim3 1s linear infinite;
    animation-delay: .5s
}

@keyframes btn-anim3 {
    0% {
        right: -100%;
    }

    50%,
    100% {
        right: 100%;
    }
}

.login-box a .prog:nth-child(4) {
    bottom: -100%;
    left: 0;
    width: 2px;
    height: 100%;
    background: linear-gradient(360deg, transparent, #03e9f4);
    animation: btn-anim4 1s linear infinite;
    animation-delay: .75s
}

@keyframes btn-anim4 {
    0% {
        bottom: -100%;
    }

    50%,
    100% {
        bottom: 100%;
    }
}
</style>